local myname="ZifnabsBufmon"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={bufmon=Me} else ZifnabsMod.bufmon=Me end
local mod
local L
local db
local MAXPETBUFS=8
local mydb
local widget={tbuf={}}
local targets={player={human=true,short="1"},playerpet={pet=true,short="1 pet"}}
local durations={}
local bufs={}
local previousbufs={}
local castremain={now=0,casts={ban=30,soulstone=30*60,fear=20}}

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	local PLAYERNAME=UnitName("player")
	if db.bufmon and db.bufmon[PLAYERNAME] then 
		fwinfo.dbpc.bufmon=mod.f:CopyTable(db.bufmon[PLAYERNAME]) 
		db.bufmon[PLAYERNAME]=nil
	end -- Umstellungvon DB...PLAYERNAME auf MYDB mit r191031a
	if not fwinfo.dbpc.bufmon then
		fwinfo.dbpc.bufmon={own=true, quiet=false, active=true, minduration=300, fadingtime=15, warnfading=true, warnfaded=true, showpets=true, warnmybufs=true, warnbufs2me=true} 
	end
	mydb=fwinfo.dbpc.bufmon
	if mydb.own==nil then mydb.own=true end -- Neu ab r200524c
	if mydb.showremain==nil or false then 
		local _,class,_=UnitClass("player")
		mydb.showremain=(class=="WARLOCK")
	end
	for n=1,4,1 do
		targets["party"..n]={human=true,short=n+1}
		targets["party"..n.."pet"]={pet=true,short=(n+1).." pet"}
	end
	for n=1,39,1 do
		targets["raid"..n]={human=true}
		targets["raid"..n.."pet"]={pet=true}
	end
end

function Me:PostInit()
	widget.pet={}
	for p=1,4,1 do
		widget.pet[p]=mod.ui:newFrame(myname.."_Pet_"..p,24,24,UIParent,"TOPLEFT","TOPLEFT",20,-100-80*p,{transparent=true})
		widget.pet[p].head=mod.ui:newButton(myname.."_Pet_"..p.."_head",20,20,widget.pet[p],"TOPLEFT","TOPLEFT",0,0,{inherit="Zifnabs_MM",click=Me.TargetPet})
		widget.pet[p].head:SetBackdrop(nil)
		widget.pet[p].head:SetNormalTexture(nil)
		widget.pet[p].life100=mod.ui:newButton(myname.."_Pet_"..p.."_life100",60,4,widget.pet[p],"TOPLEFT","TOPLEFT",25,0,{inherit="Zifnabs_MM"})
		widget.pet[p].life100:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
		widget.pet[p].life100:SetNormalTexture(nil)
		widget.pet[p].life100:SetBackdropColor(0,0,0)
		widget.pet[p].life=mod.ui:newButton(myname.."_Pet_"..p.."_life",50,4,widget.pet[p].life100,"TOPLEFT","TOPLEFT",0,0,{inherit="Zifnabs_MM"})
		widget.pet[p].life:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
		widget.pet[p].life:SetNormalTexture(nil)
		widget.pet[p].life:SetBackdropColor(0,1,0)
		widget.pet[p].life:Hide()
		widget.pet[p].life100:Hide()
		widget.pet[p].buf={}
		for buf=1,MAXPETBUFS,1 do
			widget.pet[p].buf[buf]=mod.ui:newButton(myname.."_Pet_"..p.."_buf_"..buf,10,10,widget.pet[p].life100,"BOTTOMLEFT","TOPLEFT",11*buf-11,-1,{inherit="Zifnabs_MM"})
			widget.pet[p].buf[buf]:SetBackdrop(nil)
			widget.pet[p].buf[buf]:SetNormalTexture(nil)
		end
	end
	widget.tbuf[0]=mod.ui:newFrame(myname.."_TBuf_",8*14,18,UIParent,"TOPLEFT","TOPLEFT",5,-5,{transparent=true})
	for tbuf=1,8,1 do
		widget.tbuf[tbuf]=mod.ui:newButton(myname.."_TBuf_"..tbuf,14,14,widget.tbuf[0],"TOPLEFT","TOPLEFT",14*tbuf-14,-4,{inherit="Zifnabs_MM"})
		widget.tbuf[tbuf]:SetBackdrop(nil)
		widget.tbuf[tbuf]:SetNormalTexture(nil)
		widget.tbuf[tbuf]:Show()
	end	
	Me:Activate(mydb.active)
end

function Me:Activate(set)
	if set then 
		mod.core:Register4Event("TICK","bufmon",Me.Tick) 
		mod.core:Register4Event("UNIT_SPELLCAST_SUCCEEDED","bufmon",Me.UNIT_SPELLCAST_SUCCEEDED)
	else 
		mod.core:DeRegister4Event("TICK","bufmon",Me.Tick) 
		mod.core:DeRegister4Event("UNIT_SPELLCAST_SUCCEEDED","bufmon",Me.UNIT_SPELLCAST_SUCCEEDED)
	end
	Me:ShowRemaining(0)
end

-- --------------------------------------------------------------------------------------
-- TICK
-- --------------------------------------------------------------------------------------
function Me:Tick(elapsed,online)
	Me:ShowRemaining(elapsed)
	
	bufs={}
	Me:CheckTarget("player")

	if UnitInParty("player") then
		for n=1,4,1 do Me:CheckTarget("party"..n) end
	elseif UnitInRaid("player") then
		for n=1,39,1 do Me:CheckTarget("raid"..n) end
	end
	
	if mydb.warnfaded then
		local now=GetTime()
		for id,buf in pairs(previousbufs) do
			if not bufs[id] and buf.expire<=now then
				Me:Warn(L.msg.buffaded,buf.bufname,buf.caster,buf.castername,buf.target,buf.unitname,buf.icon)
			end
		end
	end
	previousbufs=bufs
	
	-- Show Pet Information
	if mydb.showpets then
		for nr=1,4,1 do
			local pet="party"..nr.."pet"
			if UnitExists(pet) then
				local health=UnitHealth(pet)
				local maxhealth=UnitHealthMax(pet)
				widget.pet[nr].head:SetNormalTexture(peticon or 135792) -- TODO PET ICON einsetzen
				widget.pet[nr].head.petid=pet
				widget.pet[nr].head.tooltipText=UnitName(pet) or "Pet "..nr
				widget.pet[nr].head:Show()
				widget.pet[nr].life:SetWidth(math.min(60,math.max(1,60*health/maxhealth)))
				widget.pet[nr].life.tooltipText=health.."/"..maxhealth
				widget.pet[nr].life100.tooltipText=health.."/"..maxhealth
				widget.pet[nr].life100:Show()
				widget.pet[nr].life:Hide()
				widget.pet[nr].life:Show()
				local pb=0
				for btn=1,2,1 do
					for buf=1,40,1 do	
						local name,icon,wtf=UnitBuff(pet,buf)
						if btn==2 then name,icon,wtf=UnitDebuff(pet,buf) end
						if name and pb<MAXPETBUFS then
							pb=pb+1
							widget.pet[nr].buf[pb]:SetNormalTexture(icon)
							widget.pet[nr].buf[pb].tooltipText=name
							widget.pet[nr].buf[pb]:Show()
						end
					end
				end
				if pb<MAXPETBUFS then for h=pb+1,MAXPETBUFS,1 do widget.pet[nr].buf[h]:Hide() end end
				widget.pet[nr]:Show()
			elseif widget.pet[nr]:IsVisible() then 
				widget.pet[nr]:Hide()
				-- Der Rest ist BESCHEUERT! Das sollte alles mit dem Frame versteckt werden!
				widget.pet[nr].head:Hide()
				widget.pet[nr].life:Hide()
				widget.pet[nr].life100:Hide()
				for buf=1,MAXPETBUFS,1 do widget.pet[nr].buf[buf]:Hide() end
			end
		end
	end

	-- Check Bufs on target
	local bufn=0
	if mydb.own and UnitExists("target") then
		local helpharm="HELPFUL"
		local nr=0
		for check=1,40,1 do
			nr=nr+1
			local name,icon,rank,bufftype,duration, expire, caster=UnitAura("target",nr,"PLAYER|"..helpharm)
			if bufn==8 then break end
			if not name then
				if helpharm=="HELPFUL" then
					helpharm="HARMFUL"
					nr=0
				else
					break
				end
			end
			if caster=="player" then
				bufn=bufn+1
				widget.tbuf[bufn]:SetNormalTexture(icon)
				widget.tbuf[bufn].tooltipText=name
				widget.tbuf[bufn]:Show()
			end
		end
	end
	for hide=bufn+1,8,1 do
		widget.tbuf[hide]:Hide()
	end
end

-- --------------------------------------------------------------------------------------
-- SHOW REMAINING SPELL TIME
-- --------------------------------------------------------------------------------------
function Me:ShowRemaining(elapsed)
	castremain.now=castremain.now+elapsed
	if mydb.showremain then
		if not widget.remaining then
			widget.remaining={}
			widget.remaining.frame=mod.ui:newFrame(myname.."_Remaining",30,8,UIParent,"CENTER","CENTER",0,-80,{transparent=true})
			widget.remaining.ban=mod.ui:newButton(myname.."_Remain_Ban",30,30,widget.remaining.frame,"TOP","TOP",-28,-5,{inherit="Zifnabs_MM",tt=L.msg.ttBan})
			widget.remaining.ban.ttEmpty=L.msg.ttBan
			widget.remaining.ban:SetNormalTexture(136135) 
			widget.remaining.ban:SetAlpha(0.3)
			widget.remaining.soulstone=mod.ui:newButton(myname.."_Remain_Soulstone",30,30,widget.remaining.frame,"TOP","TOP",0,-5,{inherit="Zifnabs_MM",tt=L.msg.ttSoulstone})
			widget.remaining.soulstone.ttEmpty=L.msg.ttSoulstone
			widget.remaining.soulstone:SetNormalTexture(136210) 
			widget.remaining.soulstone:SetAlpha(0.3)
			widget.remaining.fear=mod.ui:newButton(myname.."_Remain_Fear",30,30,widget.remaining.frame,"TOP","TOP",0,23,{inherit="Zifnabs_MM",tt=L.msg.ttFear})
			widget.remaining.fear.ttEmpty=L.msg.ttFear
			widget.remaining.fear:SetNormalTexture(136183) 
			widget.remaining.fear:SetAlpha(0.3)
		end
		widget.remaining.frame:Show()
		for what,lasting in pairs(castremain.casts) do
			if castremain[what] then
				if castremain[what]<=castremain.now then
					widget.remaining[what]:SetAlpha(0.2)
					widget.remaining[what].Text:SetText("")
					widget.remaining[what].tooltipText=widget.remaining[what].ttEmpty
					castremain[what]=nil
				else
					local remaining=math.floor(castremain[what]-castremain.now)
					local alpha=widget.remaining[what].alpha
					if remaining<=10 then 
						alpha=1-(alpha or 0) 
					else
						if remaining>=60 then 
							remaining=math.floor(remaining/60).."m" 
						end
						alpha=1
					end
					widget.remaining[what].Text:SetText(remaining)
					widget.remaining[what].alpha=alpha
					widget.remaining[what]:SetAlpha(alpha)
				end
			end
		end
	elseif widget.remaining then
		widget.remaining.frame:Hide()
		for what,lasting in pairs(castremain.casts) do widget.remaining[what]:SetAlpha(0) end -- eigentlich Blödsinn, aber der Hide() auf den Frame geht nicht
	end
end

-- --------------------------------------------------------------------------------------
-- SPELLCAST SUCCEEDED
-- --------------------------------------------------------------------------------------
function Me:UNIT_SPELLCAST_SUCCEEDED(who,spellid,rank) 
	local spell,srank,icon,casttime,minrange,maxrange=GetSpellInfo(rank)	
--	if db.itsmemyself then print("Bufmon: "..(who or "nil")..", "..(spell or "nil")..", icon="..(icon or "nil")) end
-- 	TODO GetRaidTargetIndex("target") = nil oder 1=Star, 2=Orange, 3=Diamond, 4=Triangle, 5=Moon, 6=Square, 7=Cross, 8=Skull
	if spell==L.word.SET_SOULSTONE then
		mod.scheduler:add(castremain.casts.soulstone-60,"SSS-60","*.mod.hud:write(*.mod.f:Repl(*.L.msg.soulstonefade,{rest=60}),\"SOULSTONEOUT\")")
		castremain.soulstone=castremain.now+castremain.casts.soulstone
		widget.remaining.soulstone.tooltipText=L.msg.ttSoulstone.." ("..(UnitName("target") or "self")..")"
	elseif spell==L.word.BAN then
		castremain.ban=castremain.now+castremain.casts.ban
		widget.remaining.ban.tooltipText=L.msg.ttBan.." ("..(UnitName("target") or "self")..")"
	elseif spell==L.word.FEAR then
		castremain.fear=castremain.now+castremain.casts.fear
		widget.remaining.fear.tooltipText=L.msg.ttFear.." ("..(UnitName("target") or "self")..")"
	end
end

-- --------------------------------------------------------------------------------------
-- CHECK TARGET
-- --------------------------------------------------------------------------------------
function Me:CheckTarget(target)
	local unitname=UnitName(target)
	-- Main- and Offhand of player
	if target=="player" then
		local now=GetTime()
		local main,mainexpire,maincharges,mainid,off,offexpire,offcharges,offid=GetWeaponEnchantInfo()
		if main then 
			Me:CheckBuf(L.word.mainhand,unitname,"player","player",mainid,math.max(mainexpire-now,1800),mainexpire)
		end
		if off then
			Me:CheckBuf(L.word.offhand,unitname,"player","player",offid,math.max(offexpire-now,1800),offexpire)
		end
	end

	-- bufs on target
	for nr=1,40,1 do	
		local name,icon,rank,bufftype,duration, expire, caster=UnitAura(target,nr)
		if not name then break end
		Me:CheckBuf(name,unitname,target,caster,icon,duration,expire)
	end
	
	-- bufs on target's pet
	if UnitExists(target.."pet") then
		local unitname=UnitName(target.."pet")
		for nr=1,40,1 do	
			local name,icon,rank,bufftype,duration, expire, caster=UnitAura(target.."pet",nr)
			if not name then break end
			Me:CheckBuf(name,unitname,target.."pet",caster,icon,duration,expire)
		end
	end
end

-- --------------------------------------------------------------------------------------
-- CHECK BUF
-- --------------------------------------------------------------------------------------
function Me:CheckBuf(bufname,unitname,target,caster,icon,duration,expire)
	if target=="player" or caster=="player" then
		local use=(target=="player" and caster=="player")
		use=use or (mydb.warnbufs2me and target=="player" and caster and targets[caster] and targets[caster].human)
		use=use or (mydb.warnmybufs and caster=="player" and target and targets[target])
		use=use and not L.aura[bufname]
		if caster=="player" and duration~=0 then durations[bufname]=duration end
		if duration==0 and caster=="player" then duration=durations[bufname] or 0 end
		use=use and (duration>=mydb.minduration)
		
		if use then
			local castername=nil
			if caster then castername=UnitName(caster) end
			local bufid=unitname.." "..bufname
			local time2fade=expire-GetTime()
			bufs[bufid]={bufname=bufname,unitname=unitname,target=target,caster=caster,castername=castername,icon=icon,duration=duration,expire=expire,time2fade=time2fade}
			if time2fade>=0 and time2fade<=mydb.fadingtime and previousbufs[bufid] and previousbufs[bufid].time2fade>mydb.fadingtime and mydb.warnfading then
				Me:Warn(L.msg.buffading,bufname,caster,castername,target,unitname,icon)
			end
		end		
	end
end

-- --------------------------------------------------------------------------------------
-- ISSUE WARNING MESSAGE
-- --------------------------------------------------------------------------------------
function Me:Warn(msg,bufname,caster,castername,target,targetname,icon)
	local tgt=targetname or ""
	if target=="player" then tgt=""
	elseif targets[target] then tgt="("..mod.f:Color(targets[target].short,"ff4040")..") "..(targetname or "nil").." " end
	local castby=""
	if caster and caster~="player" then castby=" ("..L.word.by.." "..(castername or caster)..")" end
	local sound="dingding.mp3"
	if mydb.quiet then sound=nil end
	mod.hud:write(tgt..mod.f:Repl(msg,{buf=bufname})..castby,sound,icon)
end

-- --------------------------------------------------------------------------------------
-- TARGET PET
-- --------------------------------------------------------------------------------------
function Me:TargetPet(button,parse) 
	print("targeting "..(button.petid or "nil").." only allowed for Blizzard internal code, not for AddOns, so I'll skip that")
--	TargetUnit(button.petid) 
end


-- --------------------------------------------------------------------------------------
-- IDENTIFY CONFIG FRAMES
-- --------------------------------------------------------------------------------------
function Me:IdentifyConfigs() return {[1]=L.config.bufmon} end

-- --------------------------------------------------------------------------------------
-- START CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	config={changed=false}
	if not widget.config then
		widget.config={}
		widget.config.active=mod.ui:newCheck(myname.."_active",20,20,frame,"TOPLEFT","TOPLEFT",20,-10,{text=L.config.bufmon.." "..L.word.active,check=mydb.active,click=Me.ConfigChange})
		widget.config.quiet=mod.ui:newCheck(myname.."_quiet",20,20,frame,"TOPLEFT","TOPLEFT",320,-10,{text=L.word.quietbufwarn,check=(mydb.quiet==true),click=Me.ConfigChange})
		widget.config.minduration=mod.ui:newSlider(myname.."_minduration",200,20,frame,"TOPLEFT","TOPLEFT",20,-50,{min=0,max=600,text=L.word.minduration,val=mydb.minduration,click=Me.ConfigChange})
		widget.config.warnfaded=mod.ui:newCheck(myname.."_warnfaded",20,20,frame,"TOPLEFT","TOPLEFT",20,-90,{text=L.word.warnfaded,check=mydb.warnfaded,click=Me.ConfigChange})
		widget.config.warnfading=mod.ui:newCheck(myname.."_warnfading",20,20,frame,"TOPLEFT","TOPLEFT",20,-110,{text=L.word.warnfading,check=mydb.warnfading,click=Me.ConfigChange})
		widget.config.fadingtime=mod.ui:newSlider(myname.."_fadingtime",200,20,frame,"TOPLEFT","TOPLEFT",20,-145,{min=0,max=60,text=L.word.fadingtime,val=mydb.fadingtime,click=Me.ConfigChange})
		widget.config.warnmybufs=mod.ui:newCheck(myname.."_warnmybufs",20,20,frame,"TOPLEFT","TOPLEFT",20,-220,{text=L.word.warnmybufs,check=mydb.warnmybufs,click=Me.ConfigChange})
		widget.config.warnbufs2me=mod.ui:newCheck(myname.."_warnbufs2me",20,20,frame,"TOPLEFT","TOPLEFT",20,-240,{text=L.word.warnbufs2me,check=mydb.warnbufs2me,click=Me.ConfigChange})
		widget.config.showpets=mod.ui:newCheck(myname.."_showpets",20,20,frame,"TOPLEFT","TOPLEFT",20,-270,{text=L.word.showpets,check=mydb.showpets,click=Me.ConfigChange})
		widget.config.ownauras=mod.ui:newCheck(myname.."_ownauras",20,20,frame,"TOPLEFT","TOPLEFT",20,-300,{text=L.msg.ownauras,check=mydb.own,click=Me.ConfigChange})
		widget.config.showremain=mod.ui:newCheck(myname.."_showremain",20,20,frame,"TOPLEFT","TOPLEFT",20,-330,{text=L.msg.showremain,check=mydb.showremain,click=Me.ConfigChange})
	else
		widget.config.active:SetChecked(mydb.active)
		widget.config.minduration:SetValue(mydb.minduration)
		widget.config.warnfading:SetChecked(mydb.warnfading)
		widget.config.fadingtime:SetValue(mydb.fadingtime)
		widget.config.warnfaded:SetChecked(mydb.warnfaded)
		widget.config.showpets:SetChecked(mydb.showpets)
		widget.config.warnmybufs:SetChecked(mydb.warnmybufs)
		widget.config.warnbufs2me:SetChecked(mydb.warnbufs2me)
		widget.config.ownauras:SetChecked(mydb.own)
		widget.config.showremain:SetChecked(mydb.showremain)
	end
end

-- --------------------------------------------------------------------------------------
-- CONFIG CHECK FOR CHANGES
-- --------------------------------------------------------------------------------------
function Me:ConfigChange(button,parse)
	config.changed=(widget.config.active:GetChecked()~=mydb.active)
	config.changed=config.changed or (widget.config.minduration:GetValue()~=mydb.minduration)
	config.changed=config.changed or (widget.config.fadingtime:GetValue()~=mydb.fadingtime)
	config.changed=config.changed or (widget.config.warnfading:GetChecked()~=mydb.warnfading)
	config.changed=config.changed or (widget.config.warnfaded:GetChecked()~=mydb.warnfaded)
	config.changed=config.changed or (widget.config.showpets:GetChecked()~=mydb.showpets)
	config.changed=config.changed or (widget.config.warnmybufs:GetChecked()~=mydb.warnmybufs)
	config.changed=config.changed or (widget.config.warnbufs2me:GetChecked()~=mydb.warnbufs2me)
	config.changed=config.changed or (widget.config.quiet:GetChecked()~=(mydb.quiet==true))
	config.changed=config.changed or (widget.config.ownauras:GetChecked()~=mydb.own)
	config.changed=config.changed or (widget.config.showremain:GetChecked()~=mydb.showremain)
	mod.core:SetUnsavedChanges(config.changed)
end

-- --------------------------------------------------------------------------------------
-- SAVE CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	mydb.active=widget.config.active:GetChecked()
	mydb.minduration=widget.config.minduration:GetValue()
	mydb.fadingtime=widget.config.fadingtime:GetValue()
	mydb.warnfading=widget.config.warnfading:GetChecked()
	mydb.warnfaded=widget.config.warnfaded:GetChecked()
	mydb.showpets=widget.config.showpets:GetChecked()
	mydb.warnmybufs=widget.config.warnmybufs:GetChecked()
	mydb.warnbufs2me=widget.config.warnbufs2me:GetChecked()
	mydb.quiet=widget.config.quiet:GetChecked()
	mydb.own=widget.config.ownauras:GetChecked()
	mydb.showremain=widget.config.showremain:GetChecked()
	config.changed=false
	Me:Activate(mydb.active)
	Me:ShowRemaining(0)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) 
	Me:StartConfig(frame)
	return true 
end